import datetime
import requests
from numpy import random
import wikipediaapi

time_now = datetime.datetime.now().strftime("%H:%M:%S")


def run_assistent(assistant):
    assistant.speak("Hello! I am your voice assistant.")
    assistant.speak("What can I do for you?")
    while True:
        text = assistant.listen()
        if text:
            response = assistant.get_response(text)
            assistant.speak(response)
            if response == "goodbye":
                break

def get_weather(assistant, city=None):
    weather_api_key = "e77683d26e79a7f1d8c7f944c4df4af3"
    assistant.speak("Do you want to know weather for today or tomorrow?")
    weather_time = assistant.listen()

    if city is None:
        assistant.speak(f"In which city should I check the weather?")
        city = assistant.listen()

        if city == "exit":
            return "Let's do something else. What do you want me to check?"

    if weather_time == "today":
        return get_weather_today(city, weather_api_key)
    elif weather_time == "tomorrow":
        return get_weather_tomorrow(city, weather_api_key)
    elif weather_time == "exit":
        return "Let's do something else. What do you want me to check?"
    
    
def get_weather_today(city, weather_api_key):
    base_url = "http://api.openweathermap.org/data/2.5/weather?"
    complete_url = f"{base_url}q={city}&appid={weather_api_key}&units=metric"
    response = requests.get(complete_url)
    data = response.json()
    
    if data["cod"] == 200:
        weather_description = data["weather"][0]["description"]
        temperature = data["main"]["temp"]
        humidity = data["main"]["humidity"]
        return f"The weather in {city} is {weather_description}. Temperature: {temperature}°C. Humidity: {humidity}%"
    else:
        return False
    
def get_weather_tomorrow(city, weather_api_key):
    base_url = "http://api.openweathermap.org/data/2.5/forecast?"
    complete_url = f"{base_url}q={city}&appid={weather_api_key}&units=metric&cnt=8"
    response = requests.get(complete_url)
    data = response.json()
    
    if data["cod"] == "200":
        weather_description = data["list"][7]["weather"][0]["description"]
        temperature = data["list"][7]["main"]["temp"]
        humidity = data["list"][7]["main"]["humidity"]
        return f"The weather in {city} will be {weather_description} tomorrow. Temperature: {temperature}°C. Humidity: {humidity}%"
    else:
        return False
    
def cat_fact(assistant):
    response = requests.get("https://cat-fact.herokuapp.com/facts")
    data = response.json()
    fact_index = random.randint(len(data))

    return data[fact_index]["text"]
    
def search_wikipedia(assistant):
    assistant.speak("What would you like to search on Wikipedia?")
    query = None
    while query is None:
        query = assistant.listen()
    if query:
        assistant.speak("Topic is correct?")
        confirm = assistant.listen()
        response = assistant.get_response(confirm)
        if response == "yes":
            query = query
        elif response == "no":
            while True:
                assistant.speak("Please give me a correct topic.")
                query = assistant.listen()
                confirm = assistant.speak("Topci is correct?")
                response = assistant.get_response(confirm)
                if response == "yes":
                    break
        wiki = wikipediaapi.Wikipedia('admin@kuboit.pl', 'en')
        page = wiki.page(query)
        print(page)
        if page.exists():
            sentences = page.summary.split(".")
            sentences = [s.strip() for s in sentences if s]
            output = assistant.search_article(query, sentences)
            return output

def goodbye(assistant):
    assistant.speak("Goodbye! Have a nice day.")


responses_dict = {
    "okay, steve": run_assistent,
    "hello, hi, welcome": "Welcome! What can I do for you?",
    "what is your name": "My name is Steve.",
    "how are you": "I am fine, thank you.",
    "where are you from": "I am from the cloud.",
    "goodbye": "Goodbye! Have a nice day.",
    "what time is it?": f"The time is {time_now}.",
    "Search on Wikipedia": search_wikipedia,
    "what day is today": f"Today is {datetime.datetime.now().strftime('%A')}.",
    "what is the weather": get_weather,
    "give me a random cat fact": cat_fact,
    "goodbye": "Goodbye! Have a nice day.",
    "yes": "yes",
    "no": "no",
    }
